/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package chess.client.logic.peace;

import chess.client.logic.BoardPosition;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author hani
 */
public class King extends Peace {

    private boolean canCastle;
    
    public King(int peaceColor, int xPos, int yPos) {
        super(KING, peaceColor, xPos, yPos);
        canCastle = true;
    }
    
    @Override
    protected boolean isValidMove(BoardPosition newPosition) {
        if (!simpleValidMove(newPosition))
            return false;
        int x = peacePosition.getXpos();
        int y = peacePosition.getYpos();
        int newX = newPosition.getXpos();
        int newY = newPosition.getYpos();
        if (newX==x+1 || newX==x-1 || newY==y+1 || newY==y-1) {
            canCastle = false;
            return true;
        }
        return false;
    }
    
    public boolean canCastle() {
        return canCastle;
    }
    
    public void setCannotCastle() {
        canCastle = false;
    }

    @Override
    public List<BoardPosition> getAttackingPositions() {
        List<BoardPosition> attackingPositions = new ArrayList<BoardPosition>();
        int x = getPosition().getXpos();
        int y = getPosition().getYpos();
        attackingPositions.add(new BoardPosition(x - 1, y));
        attackingPositions.add(new BoardPosition(x - 1, y + 1));
        attackingPositions.add(new BoardPosition(x, y + 1));
        attackingPositions.add(new BoardPosition(x + 1, y + 1));
        attackingPositions.add(new BoardPosition(x + 1, y));
        attackingPositions.add(new BoardPosition(x + 1, y - 1));
        attackingPositions.add(new BoardPosition(x, y - 1));
        attackingPositions.add(new BoardPosition(x - 1, y - 1));
        return removeNegativeAttackingPositions(attackingPositions);
    }
    
}
