/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package chess.client.logic.peace;

import chess.client.logic.BoardPosition;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author hani
 */
public class Pawn extends Peace {

    /**
     * If true means that the player has white peaces.
     */
    private boolean isWhite;

    public Pawn(int peaceColor, int initXpos, int initYpos, boolean isWhite) {
        super(PAWN, peaceColor, initXpos, initYpos);
        this.isWhite = isWhite;
    }

    @Override
    protected boolean isValidMove(BoardPosition newPosition) {
        if (!simpleValidMove(newPosition)) {
            return false;
        }
        int x = peacePosition.getXpos();
        int y = peacePosition.getYpos();
        int newX = newPosition.getXpos();
        int newY = newPosition.getYpos();

        System.out.println(getPeaceName() + " wants to move from " +
                x + "," + y + " " + newX + "," + newY);

        if (peaceColor == Peace.WHITE) {
            if (isWhite) { // is playing as white
                if ((x == newX && (y + 1) == newY) ||
                        (x == newX && (y + 2) == newY && (y == 1 || y == 6))) {
                    return true;
                }
            } else { // is playing as black
                if ((x == newX && (y - 1) == newY) ||
                        (x == newX && (y - 2) == newY && (y == 1 || y == 6))) {
                    return true;
                }
            }
        } else { // black peace
            if (!isWhite) {
                if ((x == newX && (y + 1) == newY) ||
                        (x == newX && (y + 2) == newY && (y == 1 || y == 6))) {
                    return true;
                }
            } else {
                if ((x == newX && (y - 1) == newY) ||
                        (x == newX && (y - 2) == newY && (y == 1 || y == 6))) {
                    return true;
                }
            }
        }
        return false;
    }

    @Override
    public List<BoardPosition> getAttackingPositions() {
        List<BoardPosition> attackingPositions = new ArrayList<BoardPosition>();
        int x = getPosition().getXpos();
        int y = getPosition().getYpos();
        if (isWhite) {
            attackingPositions.add(new BoardPosition(x - 1, y + 1));
            attackingPositions.add(new BoardPosition(x + 1, y + 1));
        } else {
            attackingPositions.add(new BoardPosition(x - 1, y - 1));
            attackingPositions.add(new BoardPosition(x + 1, y - 1));
        }
        return removeNegativeAttackingPositions(attackingPositions);
    }
}
