/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package chess.client.logic.peace;

import chess.client.logic.BoardPosition;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author hani
 */
public class Queen extends Peace {

    public Queen(int peaceColor, int xPos, int yPos) {
        super(QUEEN, peaceColor, xPos, yPos);
    }
    
    @Override
    protected boolean isValidMove(BoardPosition newPosition) {
        if (!simpleValidMove(newPosition))
        	return false;
        int x = peacePosition.getXpos();
        int y = peacePosition.getYpos();
        int newX = newPosition.getXpos();
        int newY = newPosition.getYpos();
        if (isOnDiagonal(x, y, newX, newY))
        	return true;
        if (x==newX || y==newY)
            return true;
        return false;
    }

    @Override
    public List<BoardPosition> getAttackingPositions() {
        List<BoardPosition> attackingPositions = new ArrayList<BoardPosition>();
        int x = getPosition().getXpos();
        int y = getPosition().getYpos();
        for (int i=0; i<8; i++) {
            attackingPositions.add(new BoardPosition(x-i, y-i));
            attackingPositions.add(new BoardPosition(x-i, y+i));
            attackingPositions.add(new BoardPosition(x+i, y+i));
            attackingPositions.add(new BoardPosition(x+i, y-i));
            attackingPositions.add(new BoardPosition(i, y));
            attackingPositions.add(new BoardPosition(x, i));
        }
        return removeNegativeAttackingPositions(attackingPositions);
    }
    
}
