package chess.server.comm;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class ChessServer extends Thread {

    private int port;
    private ServerSocket server;
    private ClientsManager manager;
    private boolean run;

    public ChessServer(int port, ClientsManager manager) {
        this.port = port;
        this.manager = manager;
        try {
            server = new ServerSocket(port);
        } catch (IOException ex) {

        }
    }

    @Override
    public void run() {
        try {
            run = true;
            while (run) {
                Socket s = server.accept();
                manager.addNewClient(s);                
            }
        } catch (IOException ex) {
            closeConnection();
        }
    }
    
    public void closeConnection() {
        run = false;
        try {
            if (server != null) {
                server.close();
                server = null;
            }
        } catch (IOException ex) {
        }
    }
}
