package chess.server.comm;

import java.io.IOException;
import java.io.InputStream;
import java.net.Socket;

public class HeartBeatClient extends Thread {

    private static final int CONNECTION_TIME_OUT = 5000;
    private Socket socket;
    private InputStream hbis;
    private String cName;
    private boolean run;
    
    private ClientsManager manager;

    public HeartBeatClient(Socket socket, ClientsManager manager) {
        try {
            this.socket = socket;
            this.socket.setSoTimeout(CONNECTION_TIME_OUT);
            this.manager = manager;
            hbis = this.socket.getInputStream();
        } catch (IOException ex) {
            
        }
    }

    @Override
    public void run() {
        run = true;
        int readBytes = 0;
        byte[] in = null;
        while (run) {
            try {
                in = new byte[1];
                readBytes = hbis.read(in, 0, 1);
                if (readBytes == -1) {
                    run = false;
                    closeConnection();
                    break;
                }

                int msg_type = Protocol.readMsgType(in);
                if (msg_type == Protocol.MSG_TYPE_NAME) {
                    in = new byte[Protocol.PACKET_SIZE - 1];
                    hbis.read(in, 0, Protocol.PACKET_SIZE - 1);
                    cName = Protocol.readClientFrom(in);
                } else if (msg_type == Protocol.MSG_TYPE_HEART_BEAT) {

                }
            } catch (IOException ex) {
                closeConnection();
            }
        }
    }

    public void closeConnection() {
        try {
            run = false;
            if (cName == null || cName.isEmpty()) {
                return;
            }
            manager.closeClientConnection(cName);
            if (hbis != null) {
                hbis.close();
            }
            if (socket != null) {
                socket.close();
            }
        } catch (IOException ex) {

        }
    }
}
