package chess.server.comm;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

public class HeartBeatServer extends Thread {

    private int port;
    private ServerSocket socket;
    private boolean run;
    private ClientsManager man;

    public HeartBeatServer(int port, ClientsManager man) {
        try {
            this.port = port;
            this.man = man;
            socket = new ServerSocket(port);
        } catch (IOException ex) {
            
        }
    }
    
    @Override
    public void run() {
        run = true;
        while (run) {
            try {
                Socket client = socket.accept();
                man.newHeartBeatClient(client);
            } catch (IOException ex) {
                
            }
        }
    }
    
    public void closeConnection() {
        run = false;
        try {
            if (socket != null) {
                socket.close();
            }
        } catch (IOException ex) {
            Logger.getLogger(HeartBeatServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
}
